<?php
/*
Plugin Name: Simple Cache
Version: 1.0
Plugin URI: 
Description: Simple set of caching functions. Useful for plugin authors to build off of.
Author: Jeff Minard
Author URI: http://creatimation.net/
*/


define(CACHE_DIR, ABSPATH . 'wp-content/simple-cache');

if ( !file_exists(CACHE_DIR) ) {
	//ack, no cache dir created - try to make one
	if ( is_writable( dirname(CACHE_DIR) ) ) {
		// parent folder is writeable, try to make a dir.
		$dir = @mkdir( CACHE_DIR, 0666);
		if($dir == false) {
			// tried to make cache folder and failed.
			die("Your cache directory (<code>" . CACHE_DIR . "</code>) needs and be writable for this plugin to work. Double-check it. <a href='" . get_settings('siteurl') . "/wp-admin/plugins.php?action=deactivate&amp;plugin=simple-cache.php'>Deactivate the Simple Cache plugin</a>.");
		}
	} else {
		// parent is unwrite able, and we have no chache folder.
		die("The simple-cache plugin cache directory (<code>" . CACHE_DIR . "</code>) needs to exist and be writable for this plugin to work. Double-check it. <a href='" . get_settings('siteurl') . "/wp-admin/plugins.php?action=deactivate&amp;plugin=simple-cache.php'>Deactivate the Simple Cache plugin</a>.");
	}
} 


function cache_recall($func_call, $stale_age=15) {

	$filename = CACHE_DIR . md5($func_call) . '.txt';

	if( !file_exists($filename) ) {
		// this function call has not been cached before
		return false;
	}

	if ( filemtime($filename) < strtotime("$stale_age minutes ago") ) {
		// file contents are too old!
		return false;
	}

	$cached_content = file_get_contents($filename);

	return $cached_content;

}

function cache_store($func_call, $content) {

	$filename = CACHE_DIR . md5($func_call) . '.txt';

	if (!$handle = @fopen($filename, 'w')) {
		// Can't open file?
		return false;
	}

	if (fwrite($handle, $content) === FALSE) {
		// Write fail?
		return false;
	}

	fclose($handle);

	return true;

}


?>